"""# MSWord Document Product for Zope - MSWord.py
# Copyright (C) 2001 ric BARROCA <eric@barroca.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# MSWord.py : Python module providing an interface to convert
#			  MSWord documents into HTML documents using vwWare (formerly
#			  called mswordview).
#
# Variables :
#	- data (string) : contains the MSWord Document (usualy got from a 
#					  "data = file.read()")
#	- name (string) : the document's filename
# /usr/local/bin/wvConvert is on Darth rml nov6 2002
# modified to become an external file started nov6 2002
# please adjust self.basepath!
"""

__version__='$Revision: 1.1 $'
__author__= '$Author: rerla $'
__date__= '$Date: 2002/11/14 18:41:03 $'

import re, os

class MSWordDoc:

	def __init__(self, name, data, relpath):
		"""Initialization : create work directory (base plus zope path) and copy the document into a file."""
		self.prefix = '/usr/local' # The path prefix where wvWare ist installed (usualy /usr or /usr/local)
		self.basepath = '/usr/local/zopeinstancehome/docfilestore'
		self.relpath = relpath  # returns site relative path
		if relpath[0] in ['/','\\']:
			self.relpath = relpath[1:]
		# need to ensure that path exists
		self.path = os.path.join(self.basepath,self.relpath)
		if not os.path.exists(self.path):
			os.makedirs(self.path)
		self.name = name
		self.size = len(data)
		filedest = open('%s' % (os.path.join(self.path,name + '.doc')), 'w')
		filedest.write(data)
		filedest.close()
	
	def Convert(self):
		"Convert the document"
		os.system('cd "%s" && %s/bin/wvWare -x %s/lib/wv/wvZope.xml "%s.doc" > "%s.html"' % \
				  (self.path, self.prefix, self.prefix, self.name, self.name))
		htmlfile = open("%s.html" % (os.path.join(self.path, self.name)), 'r')
		h = htmlfile.read()
		self.htmlsize = len(h)
		os.system('cd "%s" && %s/bin/wvPDF "%s.doc" "%s.pdf"' % \
				  (self.path, self.prefix, self.name, self.name))
		pdffile = open("%s.pdf" % (os.path.join(self.path, self.name)), 'r')
		pdf = pdffile.read()
		self.pdfsize = len(pdf)

	def getDocHTML(self):
		htmlfile = open("%s.html" % (os.path.join(self.path, self.name)), 'r')
		html = htmlfile.read()
		htmlfile.close()
		return html
	
	def getDocPDF(self):
		htmlfile = open("%s.pdf" % (os.path.join(self.path, self.name)), 'r')
		html = htmlfile.read()
		htmlfile.close()
		return html

	def getDoc(self):
		htmlfile = open("%s.doc" % (os.path.join(self.path, self.name)), 'r')
		html = htmlfile.read()
		htmlfile.close()
		return html

	def getImgs(self):
		imgs = []
		for f in os.listdir(self.path):
			result = re.match("^.+\.(?P<ext>.+)$", f)
			if result is not None:
				ext = result.group('ext') 
				if ext in ('png', 'jpg', 'gif', 'wmz', 'wmf'): imgs.append(f)
		path = "%s/" % self.path
		return path, imgs
"""
$Log:
MSWord.py,v $
Revision 1.7  2002/11/11 14:57:19  rerla
still unuseable - manage_upload is broken due to name/id mess

Revision 1.6  2002/11/11 03:33:23  rerla
A better almost working version (!)

Revision 1.5  2002/11/11 03:13:18  rerla
First almost working version (!)

Revision 1.4  2002/11/11 02:53:40  rerla
Getting closer.
Now testing
Still broken

Revision 1.3  2002/11/10 20:44:39  rerla
Getting closer. Looks like I can just manage the files without extfile.
Still not ready for testing

Revision 1.2  2002/11/07 01:45:33  rerla
On our way to externalfile based version
Convert now makes  pdf. getDocPDF returns it
All stored in filesystem

"""